;;;     GRUPVYN.LSP - Written by Vetal 
;;;    
;;;     Copyright (C) 1999 by Minskgrazhdanproekt.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun vyngr_vv ( / m pt pt1 pt2 p1 p2 p3 p4 flag e txt txt1 l osm)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p1 (getpoint "\n  : "))
   (command "_.ortho" "_on")
   (initget 1)
   (setq p2 (getpoint p1 "\n  : "))
   (if (< (abs (- (car p1) (car p2))) (abs (- (cadr p1) (cadr p2))))
      (setq p2 (list (car p1) (cadr p2)))
      (setq p2 (list (car p2) (cadr p1)))
   )
   (command "_.line" "_non" p1 "_non" p2 "")
   (setq e (entlast)
         txt (getstring T "\n : ")
         txt1 (getstring T "\n : ")
   )
   (cond
     ((and (= txt "") (= txt1 "")) (setq l (* vet1 10)))
     ((= txt "") (setq l (tlen_v txt1)))
     ((= txt1 "") (setq l (tlen_v txt)))
     (T (setq l (max (tlen_v txt) (tlen_v txt1))))
   )
   (cond
     ((= (cadr p1) (cadr p2)) 
         (progn
           (if (< (car p1) (car p2)) (setq m 1))
           (if (> (car p1) (car p2)) (setq m -1))
           (setq p2 (rc p2 (* m (+ (* 3 vet1) l)) 0))
           (entdel e)
           (command "_.line" "_non" p1 "_non" p2 "")
           (setq e (entlast))
         )
     )
     ((= (car p1) (car p2))
         (progn
           (setq m -1)
           (command "_.line" "_non" p2 "_non" (rc p2 (+ (* 3 vet1) l) 0) "")
         )
     )
     (T (exit))
   )
   (setq osm (getvar "OSMODE"))
   (setvar "OSMODE" 0)
   (vet_txt (rc p2 (* m -0.5 (+ (* 3 vet1) l)) 0) "_bc" txt 0)
   (vet_txt (rc p2 (* m -0.5 (+ (* 3 vet1) l)) (* vet1 -0.7)) "_tc" txt1 0)
   (setvar "OSMODE" osm)
   (command "_.ortho" "_off")
   (initget 1)
   (setq p3 (getpoint p1 "\n  : "))
   (command "_.line" "_non" p3 "_non" p1 "")
   (setq al (angle p3 p1)
         pt2 p1)
   (while (not flag)
    (setq p4 (getpoint "\n<>/  : "))
    (if (= (type p4) 'LIST) (progn
      (setq pt1 (polar p4 al 10)
            pt (inters p1 p2 p4 pt1 nil))
      (if (and (equal (angle p4 pt) (angle p3 p1) 0.1)
               (equal (angle pt2 p2) (angle pt p2) 0.1))
      (progn
        (if (< (distance pt p2) (distance pt2 p2))  
          (command "_.line" "_non" p4 "_non" pt "")
        (progn
          (command "_.line" "_non" p4 "_non" pt "")
          (entdel e)
          (command "_.line" "_non" pt "_non" p2 "")
          (setq pt2 pt e (entlast))
        ))
      )
        (princ "\n .")
      )      
    )
      (setq flag T)
    )
   )
   (end_v)
   (princ)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun vynz_vv ( / m pt pt1 pt2 p1 p2 p3 p4 flag e txt txt1 l z osm)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (setq z (* 0.5 (atof (var_v "vzv"))))
   (initget 1)
   (setq p1 (getpoint "\n  : "))
   (command "_.ortho" "_on")
   (initget 1)
   (setq p2 (getpoint p1 "\n  : "))
   (if (< (abs (- (car p1) (car p2))) (abs (- (cadr p1) (cadr p2))))
      (setq p2 (list (car p1) (cadr p2)))
      (setq p2 (list (car p2) (cadr p1)))
   )
   (command "_.line" "_non" p1 "_non" p2 "")
   (setq e (entlast)
         txt (getstring T "\n : ")
         txt1 (getstring T "\n : ")
   )
   (cond
     ((and (= txt "") (= txt1 "")) (setq l (* vet1 10)))
     ((= txt "") (setq l (tlen_v txt1)))
     ((= txt1 "") (setq l (tlen_v txt)))
     (T (setq l (max (tlen_v txt) (tlen_v txt1))))
   )
   (cond
     ((= (cadr p1) (cadr p2)) 
         (progn
           (if (< (car p1) (car p2)) (setq m 1))
           (if (> (car p1) (car p2)) (setq m -1))
           (setq p2 (rc p2 (* m (+ (* 3 vet1) l)) 0))
           (entdel e)
           (command "_.line" "_non" p1 "_non" p2 "")
           (setq e (entlast))
         )
     )
     ((= (car p1) (car p2))
         (progn
           (setq m -1)
           (command "_.line" "_non" p2 "_non" (rc p2 (+ (* 3 vet1) l) 0) "")
         )
     )
     (T (exit))
   )
   (setq osm (getvar "OSMODE"))
   (setvar "OSMODE" 0)
   (vet_txt (rc p2 (* m -0.5 (+ (* 3 vet1) l)) 0) "_bc" txt 0)
   (vet_txt (rc p2 (* m -0.5 (+ (* 3 vet1) l)) (* vet1 -0.7)) "_tc" txt1 0)
   (setvar "OSMODE" osm)
   (command "_.ortho" "_off")
   (initget 1)
   (setq p3 (getpoint "\n    : "))
   (if (= (car p1) (car p2)) (setq p3 (list (car p1) (cadr p3)))
                             (setq p3 (list (car p3) (cadr p1)))
   )
   (command "_.line" "_non" (polar p3 (dtr 45) (* z vet1)) "_non" (polar p3 (dtr 225) (* z vet1)) "")
   (entdel e)
   (cond
     ((< (cadr p1) (cadr p2)) (setq p1 (rc p3 0 (*  vet1 -1 z))))      
     ((> (cadr p1) (cadr p2)) (setq p1 (rc p3 0 (*  vet1 z))))
     ((< (car p1) (car p2)) (setq p1 (rc p3 (*  vet1 -1 z) 0)))      
     ((> (car p1) (car p2)) (setq p1 (rc p3 (*  vet1 z) 0)))
   ) 
   (command "_.line" "_non" p1 "_non" p2 "")
   (setq e (entlast))
   (while (not flag)
    (setq p3 (getpoint "\n<>/    : "))
    (if (= (type p3) 'LIST) (progn
      (if (= (car p1) (car p2)) (setq p3 (list (car p1) (cadr p3)))
                               (setq p3 (list (car p3) (cadr p1)))
      )
      (command "_.line" "_non" (polar p3 (dtr 45) (* z vet1)) "_non" (polar p3 (dtr 225) (* z vet1)) "")
      (cond
        ((and (< (cadr p3) (cadr p1)) (< (cadr p1) (cadr p2)))
           (progn
             (entdel e)
             (setq p1 (rc p3 0 (*  vet1 -1 z)))      
             (command "_.line" "_non" p1 "_non" p2 "")
             (setq e (entlast)) 
        ))
        ((and (> (cadr p3) (cadr p1)) (> (cadr p1) (cadr p2)))
           (progn
             (entdel e)
             (setq p1 (rc p3 0 (*  vet1 z)))
             (command "_.line" "_non" p1 "_non" p2 "")
             (setq e (entlast)) 
        ))
        ((and (< (car p3) (car p1)) (< (car p1) (car p2)))
           (progn
             (entdel e)
             (setq p1 (rc p3 (*  vet1 -1 z) 0))      
             (command "_.line" "_non" p1 "_non" p2 "")
             (setq e (entlast)) 
        ))
        ((and (> (car p3) (car p1)) (> (car p1) (car p2)))
           (progn
             (entdel e)
             (setq p1 (rc p3 (*  vet1 z) 0))      
             (command "_.line" "_non" p1 "_non" p2 "")
             (setq e (entlast)) 
        ))
      ) 
    )
      (setq flag T)
    )
   )
   (end_v)
   (princ)
)