;;;     DETOFORM.LSP - Written by Vetal 
;;;    
;;;     Copyright (C) 1999 by Minskgrazhdanproekt.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:sech_v( / p1 p2 al1 al2 dx dy t3 p13 p14 p23 p24 txt
                   pt pt1 pt2 pt3 pt4 ug flag aa)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p1 (getpoint "\n : "))
   (setq p2 (getpoint p1 "\n< >/ : "))
   (if p2 (progn
    (vychs_v p1 p2)
    (setvar "OSMODE" 0)
    (strl_v p1 al1 1 t3)
    (setq p13 pt3 p14 pt4)
    (strl_v p2 al2 -1 t3)
    (setq p23 pt3 p24 pt4)
    (setq txt (getstring T "\n : "))
    (stt_v p13 p14 -1 txt)
    (stt_v p23 p24 1 txt)
   )
   (progn
    (setq aa (* vet1 (atof (var_v "dds"))))
    (initget 1)
    (setq pt2 (getpoint p1 "\n : "))
    (vychs_v p1 pt2)
    (setvar "OSMODE" 0)
    (strl_v p1 al1 1 t3)
    (setq p13 pt3 p14 pt4)
    (command "_.line" p1 pt2 "")
    (setvar "OSMODE" osm_v)
    (setq pt (getpoint pt2 "\n : "))
    (entdel (entlast))
    (command "_.pline" "_non" (polar_v pt2 p1 0 aa) "_w" (* 0.5 vet1) (* 0.5 vet1)
                       "_non" pt2 "_non" (polar_v pt2 pt 0 aa) "")
    (while (not flag)
     (setq pt1 pt2 pt2 pt)
     (command "_.line" "_non" pt1 "_non" pt2 "")
     (setq pt (getpoint pt2 "\n< >/ : "))
     (if (not pt) (setq flag T)
     (progn
      (entdel (entlast))
      (command "_.pline" "_non" (polar_v pt2 pt1 0 aa) "_w" (* 0.5 vet1) (* 0.5 vet1)
                         "_non" pt2 "_non" (polar_v pt2 pt 0 aa) "")
     ))
    )
    (entdel (entlast))
    (vychs_v pt1 pt2)
    (setvar "OSMODE" 0)
    (strl_v pt2 al2 -1 t3)
    (setq p23 pt3 p24 pt4)
    (setq txt (getstring T "\n : "))
    (stt_v p13 p14 -1 txt)
    (stt_v p23 p24 1 txt)
   ))
   (end_v)
   (princ)
)

(defun vychs_v (p1 p2)

     (if (= (car p1) (car p2))
     (progn
         (setq dx 0)
         (if (< (cadr p1) (cadr p2))
           (setq al2 (/ pi 2 )
                 al1 (* pi 1.5))
           (setq al1 (/ pi 2 )
                 al2 (* pi 1.5))
         )
     )
     (progn
        (setq dx (- (car p2) (car p1))
              dy (- (cadr p2) (cadr p1))
              ug (/ dy dx)
              al1 (+ (atan ug) pi)
              al2 (atan ug))
     ))
    (setq t3 1)
    (if (< (car p2) (car p1)) (setq t3 -1))
)

(defun  stt_v (pn pk t1 tt / aa pp al b)

   (setq aa (angle pn pk))
   (if (= t1 -1)
    (progn
    (if (and (<= aa (* 0.75 pi)) (>= aa (* 0.25 pi)))
      (setq b "_bl" al (- (rtd aa) 90)))
    (if (and (<= aa (* 1.75 pi)) (>= aa (* 1.25 pi)))
      (setq b "_tr" al (+ (rtd aa) 90)))
    (if (and (< aa (* 1.25 pi)) (> aa (* 0.75 pi)))
      (setq b "_br" al (- (rtd aa) 180)))
    (if (or (< aa (* 0.25 pi)) (> aa (* 1.75 pi)))
      (setq b "_tl" al (rtd aa)))
    )
    (progn
    (if (and (<= aa (* 0.75 pi)) (>= aa (* 0.25 pi)))
      (setq b "_br" al (- (rtd aa) 90)))
    (if (and (<= aa (* 1.75 pi)) (>= aa (* 1.25 pi)))
      (setq b "_tl" al (+ (rtd aa) 90)))
    (if (and (< aa (* 1.25 pi)) (> aa (* 0.75 pi)))
      (setq b "_tr" al (- (rtd aa) 180)))
    (if (or (< aa (* 0.25 pi)) (> aa (* 1.75 pi)))
      (setq b "_bl" al (rtd aa)))
    ))
   (setq pp (polar_v pn pk (* 45 t1) (* vet1 2.5)))
   (vet_txt pp b tt al)
)

(defun strl_v (pt al t1 tt / av an st v dx1 dx2 dx3 dx4 dy1 dy2 dy3 dy4 pt1 pt2)
   (setq av (* (atof (var_v "ost")) vet1)
         an (* (atof (var_v "rsl")) vet1)
         st (* (atof (var_v "rst")) vet1)
         v (* (atof (var_v "rls")) vet1)
         dx1 (* av (cos al) tt)
         dx2 (* an (cos al) tt)
         dy1 (* av (sin al) tt)
         dy2 (* an (sin al) tt)
         dx3(* st (cos(+ al (* pi 0.5 t1 tt))))
         dx4(* v (cos(+ al (* pi 0.5 t1 tt))))
         dy3(* st (sin(+ al (* pi 0.5 t1 tt))))
         dy4(* v (sin(+ al (* pi 0.5 t1 tt))))
         pt1(rc pt dx1 dy1)
         pt2(rc pt dx2 dy2)
         pt3(rc pt1 dx3 dy3)
         pt4(rc pt1 dx4 dy4))
   (command "_.pline" pt "_w" (* 0.5 vet1) (* 0.5 vet1) pt2  pt1
    "_w" 0 (* 0.8 vet1) pt3 "_w" 0 0  pt4 "")
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:otm_v( / p1 p2 pt7 pt4 tx bb p3 obu txt flag ct i lot)

   (begin_v)

   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (setq ct (getvar "CECOLOR"))
   (setq p1 (getpoint "\n< >/ : "))
   (if (equal (type p1) 'LIST)
   (progn
     (command "_.ortho"  "_off")
     (initget 1)
     (setq p2 (getpoint p1 "\n : "))
     (setvar "OSMODE" 0)
     (otmdraw p1 p2)
     (setq pt7 (rc pt4 (* 5 tx vet1) 0))
     (if (< tx 0) (setq bb "_br") (setq bb "_bl"))
     (setq txt (getstring "\n <0.000>: "))
     (setq txt (rtos_ot txt))
     (setvar "CECOLOR" (var_v "cto"))
     (vet_txt pt7 bb txt 0)
     (setvar "CECOLOR" ct)
    )
   (progn
   (if T
   (progn
     (if (= vet2 0) (setq vet2 (mas_v)))
     (command "_.ortho"  "_off")
     (initget 1)
     (setq p3 (getpoint "\n   : "))
     (setq olt "0.000")
     (if (/= oldp3 nil) (progn
         (setq dd (* (- (cadr p3) (cadr oldp3)) vet2 0.001))
         (setq otmv (+ oldobu dd))
         (setq olt (rtos otmv 2 3)))
     )
     (setq obu (getreal (strcat "\n   <" olt ">: ")))
     (if (= obu nil) (setq obu (atof olt)))
     (setq oldp3 p3 oldobu obu)
     (while (not flag)
      (if (not lot) 
        (setq p1 (getpoint "\n<>/ : "))
        (progn
         (initget 128)
         (setq p1 (getpoint "\n<>/(_u)/ : "))
        )
      )
      (cond
       ((equal (type p1) 'LIST)
        (progn
         (initget 1)
         (setq p2 (getpoint p1 "\n : "))
         (setvar "OSMODE" 0)
         (otmdraw p1 p2)
         (setq pt7 (rc pt4 (* 5 tx vet1) 0))
         (setq dd (* (- (cadr p1) (cadr p3)) vet2 0.001))
         (setq otmv (+ obu dd))
         (setq oldtxt (rtos_ot (rtos otmv 2 3)))
;         (if (> otmv 0) (setq oldtxt (strcat "+" oldtxt)))
         (setq txt (getstring (strcat "\n <" oldtxt ">: ")))
         (if (= txt "") (setq txt oldtxt)
         (setq txt (rtos_ot txt)))
         (if (< tx 0) (setq bb "_br") (setq bb "_bl"))
         (setvar "CECOLOR" (var_v "cto"))
         (vet_txt pt7 bb txt 0)
         (setq lot (cons (entlast) lot))
         (setq eend_v (entlast))
         (setvar "CECOLOR" ct)
         (setvar "OSMODE" osm_v)
        )
       )
       ((equal p1 "_u")
        (progn
          (setq i 0)
          (while (< i 4)
           (entdel (car lot))
           (if (= (length lot) 1) (setq lot nil)
             (setq lot (cdr lot))
           )
           (setq i (1+ i))
          )
        )
       )
       ((not p1) (setq flag T))
      );cond
     );while
   ))
   ))
   (setq eend_v nil)
   (end_v)
   (princ)
)

(defun rtos_ot(txt / a b d)
   (setq b (- (* (abs (atof txt)) 1000) (* (fix (abs (atof txt))) 1000)))
   (cond 
      ((< b 10) (setq a (strcat "00" (rtos b 2 0))))
      ((< b 100) (setq a (strcat "0" (rtos b 2 0))))
      (T (setq a (rtos b 2 0)))
   )     
   (cond
      ((= (atof txt) 0) (strcat "%%p" (itoa (fix (atof txt))) "." a))
      ((> (atof txt) 0) (strcat "+" (itoa (fix (atof txt))) "." a))
      (T (strcat "-" (itoa (abs (fix (atof txt)))) "." a))
   )   
)


(defun otmdraw (p1 p2 / a1 a2 a4 a5 pt1 pt2 pt3 pt5 pt6)

   (setq a1 (* (atof (var_v "hpl")) vet1))
   (setq a2 (* (atof (var_v "str")) vet1))
   (setq a4 (* (atof (var_v "bpl")) vet1))
   (setq a5 (* (atof (var_v "zvl")) vet1))
   (if (and (<= (angle p1 p2) pi) (> (angle p1 p2) (* 0.5 pi)))
      (setq tx -1 ty 1))
   (if (and (<= (angle p1 p2) (* 1.5 pi)) (> (angle p1 p2) pi))
      (setq tx -1 ty -1))
   (if (and (<= (angle p1 p2) (* 0.5 pi)) (> (angle p1 p2) 0))
      (setq tx 1 ty 1))
   (if (and (<= (angle p1 p2) (* 2 pi)) (> (angle p1 p2) (* 1.5 pi)))
      (setq tx 1 ty -1))
   (setq p1 (rc p1 (* vet1 (atof (var_v "ovl")) tx) 0)) 
   (setq pt1 (list (car p2) (cadr p1)))
   (setq pt2 (rc pt1 (* a2 -1) (* a2 ty) ))
   (setq pt3 (rc pt1 a2 (* a2 ty) ))
   (setq pt4 (rc pt1 0 (* a1 ty) ))
   (setq pt5 (rc pt4 (* a4 tx) 0))
   (setq pt6 (rc pt1 (* a5 tx) 0))
   (command "_.line"  p1 pt6 "")
   (setq lot (cons (entlast) lot))
   (command "_.pline" pt1 "_w" 0 0 pt4  pt5 "")
   (setq lot (cons (entlast) lot))
   (command "_.pline" pt2 "_W" (* 0.4 vet1) (* 0.4 vet1)
    pt1  pt3 "")
   (setq lot (cons (entlast) lot))
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:nuz_v( / p txt txt1)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p (getpoint "\n : "))
   (setvar "OSMODE" 0)
   (command "_.donut"  (* 10 vet1) (* 10.8 vet1) p \)
   (command "_.circle" p (* 6 vet1) \)
   (setq txt (getstring "\n<     >/ : "))
   (if (/= txt "") (vet_txt p "_m" txt 0)
   (progn
     (command "_.line" (rc p (* vet1 -4) 0) (rc p (* vet1 4) 0) \)
     (setq txt (getstring "\n : "))
     (vet_txt p "_bc" txt 0)
     (setq txt1 (getstring  "\n< >/ : "))
     (if (= txt1 "") (setq txt1 " "))
     (setq txt1 (strcat "." txt1)) 
     (vet_txt p "_tc" txt1 0)
   )) 
   (end_v)
   (princ)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:vyn_v( / p1 p2 txt txt1)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p1 (getpoint "\n   : "))
   (command "_.ortho"  "_off")
   (initget 1)
   (setq p2 (getpoint  p1 "\n  : "))
   (setvar "OSMODE" 0)
   (command "_.line" p1 p2 "")
   (setq txt (getstring T "\n : "))
   (setq txt1 (getstring T "\n : "))
   (entdel (entlast))
   (vyn_vv p1 p2 txt txt1)
   (end_v)
   (princ)
)

(defun vyn_vv (p1 p2 txt txt1 / dtxt m l)
   (if (= txt1 "") 
   (progn 
    (if (= txt "") (exit))
    (setq dtxt (getvar "DIMTXT"))
    (if (/= (getvar "DIMSCALE") 0)
      (setvar "DIMTXT" (/ htxt_v (getvar "DIMSCALE")))
      (setvar "DIMTXT" htxt_v)
    )
    (command "_.leader" p1 p2 "_f" "_n" "" txt "")
    (setvar "DIMTXT" dtxt)
   )
   (progn
    (if (< (car p2) (car p1)) (setq m -1) (setq m 1))
    (cond
     (T (setq l (+ (* vet1 2) (max (tlen_v txt) (tlen_v txt1)))))
    )
    (command "_.pline" p1 "_w" 0 0 p2 (rc p2 (* m l) 0) "")
    (vet_txt (rc p2 (+ (* m 0.5 l) (* 0.6 vet1 (1- m))) 0) "_bc" txt 0)
    (vet_txt (rc p2 (+ (* m 0.5 l) (* 0.6 vet1 (1- m))) (* vet1 -0.7)) "_tc" txt1 0)
   ))
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:uzel_v( / p1 p3 pt txt txt1 l m)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p1 (getpoint "\n : "))
   (princ "\n : ")
   (command "_.circle" "_non" p1 "_non" pause \)
   (command "_.ortho"  "_off")
   (initget 1)
   (setq p3 (getpoint p1 "\n   : ")
         pt (polar_v p3 p1 0 (- (distance p3 p1) (getvar "CIRCLERAD")))
   )
   (setvar "OSMODE" 0)
   (command "_.line" p3 pt "")
   (setq e (entlast))
   (if (< (car p3) (car p1)) (setq m -1) (setq m 1))
   (setq txt (getstring T "\n : ")
         txt1 (getstring T "\n: "))
   (cond
     ((and (= txt "") (= txt1 "")) (setq l (* vet1 10)))
     ((= txt "") (setq l (+ (* vet1 2) (tlen_v txt1))))
     ((= txt1 "") (setq l (+ (* vet1 2) (tlen_v txt))))
     (T (setq l (max (+ (* vet1 2) (tlen_v txt)) (+ (* vet1 2) (tlen_v txt1)))))
   )
   (entdel (entlast))
   (command "_.pline" pt "_w" 0 0 p3 (rc p3 (* m l) 0) "")
   (vet_txt (rc p3 (+ (* m 0.5 l) (* 0.5 vet1 (1- m))) 0) "_bc" txt 0)
   (vet_txt (rc p3 (+ (* m 0.5 l) (* 0.5 vet1 (1- m))) (* vet1 -0.7)) "_tc" txt1 0)
   (end_v)
   (princ)
)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun c:nsech_v( / p1 t1 txt)

   (begin_v)
   (if (= vet1 0) (setq vet1 (masl_v)))
   (if (= htxt_v 0) (setq htxt_v (hitext_v)))
   (initget 1)
   (setq p1 (getpoint "\n : "))
   (setvar "OSMODE" 0)
   (command "_.pline"  (rc p1 (* -8 vet1) 0) "_w" (* 0.4 vet1) (* 0.4 vet1)
    (rc p1 (* 8 vet1) 0) "")
   (setq t1 (getstring "\n : "))
   (setq txt (strcat t1 " - " t1))
   (vet_txt  p1 "_bc" txt 0)
   (end_v)
   (princ)
)

