;;;     VETCAD.LSP - Written by Vetal
;;;
;;;     Copyright (C) 1999-2000 by Minskgrazhdanproekt.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(setq htxt_v (getvar "USERR3")
      vet1 (getvar "USERR1")
      vet2 (getvar "USERR2")
      pref_v (substr (findfile "vetcad.lsp") 1 (- (strlen (findfile "vetcad.lsp")) 10))
)

(load (strcat pref_v "ves.lsp"))
(load (strcat pref_v "detoform.lsp"))

(defun c:svelr_v ()
   (if (not svelr_vv) (load_v "sortamv.lsp"))
   (svelr_vv)
)

(defun c:svelv_v ()
   (if (not svelv_vv) (load_v "sortamv.lsp"))
   (svelv_vv)
)

(defun c:dvutr_v ()
   (if (not dvutr_vv) (load_v "sortamv.lsp"))
   (dvutr_vv)
)

(defun c:dvutv_v ()
   (if (not dvutv_vv) (load_v "sortamv.lsp"))
   (dvutv_vv)
)

(defun c:ugr_v ()
   (if (not ugr_vv) (load_v "sortamv.lsp"))
   (ugr_vv)
)

(defun c:ugv_v ()
   (if (not ugv_vv) (load_v "sortamv.lsp"))
   (ugv_vv)
)

(defun c:svarka_v ()
   (if (not svarka_vv) (load_v "svarka.lsp"))
   (svarka_vv)
)

(defun c:shovm_v ()
   (if (not shovm_vv) (load_v "svshov.lsp"))
   (shovm_vv)
)

(defun c:shovz_v ()
   (if (not shovz_vv) (load_v "svshov.lsp"))
   (shovz_vv)
)

(defun c:vyngr_v ()
   (if (not vyngr_vv) (load_v "grupvyn.lsp"))
   (vyngr_vv)
)

(defun c:vynz_v ()
   (if (not vynz_vv) (load_v "grupvyn.lsp"))
   (vynz_vv)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(defun load_v (file_v)
    (princ "\n....    \n")
    (load (strcat pref_v file_v))
    (princ "!\n")
    (princ)
)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
(princ "\nVetCAD Utilities loaded.\n")
(princ)
